<?xml version="1.0" encoding="utf-8"?><refentry xmlns="http://docbook.org/ns/docbook" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xi="http://www.w3.org/2001/XInclude">
<info>
  <pubdate>$Date: 2007-07-23 01:34:53 +0800 (Mon, 23 Jul 2007) $</pubdate>
  <releaseinfo>$Revision: 7120 $</releaseinfo>
</info>

<refmeta>
  <refentrytitle><?tdg-refentrytitle?></refentrytitle>
  <refmiscinfo role="element">programlistingco</refmiscinfo>
  <refmiscinfo role="pattern">db.programlistingco</refmiscinfo>
</refmeta>

<refnamediv>
  <refname><?tdg-refname?></refname>
  <refpurpose><?tdg-refpurpose?></refpurpose>
</refnamediv>

<?tdg-refsynopsisdiv?>

<refsection condition="ref.description">
<title>Description</title>


<para>Callouts, such as numbered bullets, are an annotation mechanism.  In an
online system, these bullets are frequently <quote>hot,</quote> and clicking on
them sends you to the corresponding annotation.
</para>
<para>A <tag>programlistingco</tag> is a wrapper around an <tag>areaspec</tag> and
a <tag>programlisting</tag>.  An <tag>areaspec</tag> identifies the locations
(coordinates)
in the <tag>programlisting</tag> where the callouts occur.
The <tag>programlistingco</tag> may also contain the list of annotations in
a <tag>calloutlist</tag>, although the <tag>calloutlist</tag> may also
occur outside of the wrapper, elsewhere in the document.
</para>

<para>It is also possible to embed <tag>co</tag> elements directly in the
verbatim text, in order to avoid having to calculate the
correct coordinates.  If you decided to go this route, use a 
<tag>programlisting</tag> and a <tag>calloutlist</tag> without the
<tag>programlistingco</tag> wrapper.  A <tag>programlistingco</tag>
must specify at least one coordinate.
</para>

<para>For a complete description of callouts, see <tag>callout</tag>.
</para>

<refsection><title>Processing expectations</title>
<para><?tdg gentext='format.block'?>
<?tdg gentext='pexp.linespecific'?>
</para>
<para>The mandatory processing expectations of a <tag>programlistingco</tag> are
minimal: a system is expected to render the program listing and the
callout list, if present.
</para>
<para>If explicit <tag>co</tag> elements are embedded in a
<tag>programlisting</tag>, they must generate appropriate
callout marks.
</para>
<para>In online environments, the processing system may be able to instantiate
the linking relationships between the callout marks in the program listing and
the annotations.
Some systems may even be able to go a step further and generate
the callout marks automatically from the coordinate information,
but this level of sophistication is not mandatory.
</para>
</refsection>


<?tdg-attributes?>
<?tdg-parents?>
<?tdg-children?>

</refsection>

<?tdg-seealso?>

<refsection condition="ref.examples">
<title>Examples</title>

<programlisting><xi:include href="example.1.xml" parse="text"/></programlisting>

<anchor xml:id="ex.os.programlistingco.1" role="HACK-ex.out.start"/>
<xi:include href="example.1.xml" xpointer="/1/2"/>
<anchor xml:id="ex.oe.programlistingco.1" role="HACK-ex.out.end"/>

</refsection>

</refentry>